<style>
#simcheckform {
	padding:20px 0;
	margin-bottom: 2em;
}

#simchecktable tbody td {
	border: 0 !important;
	padding: .5em;
}

#member-name-results {
	padding:0;
	display:none; 
	border:1px solid #3db0c7; 
	padding:10px;
	margin:10px 0
}

#myProgress {
  width: 100%;
  background-color: #d8d2c4;
  display:none;
}

#myBar {
  width: 1%;
  height: 30px;
  background-color: #3db0c7;
}
#simcheck, #runningfor {
	text-align:center;
}
#simchecktable {
	margin:0 auto;
}

#simcheck  div {
	margin:10px auto;
  width: 100px;
  height: 100px;
  background-color: transparent;
  animation: spin 2s steps(12) infinite;
  background-image:url(/img/Asset_Load_Throbber_Load_Throbber_Teal.svg);
  /* transform: rotate(3deg); */
   /* transform: rotate(0.3rad);/ */
   /* transform: rotate(3grad); */ 
   /* transform: rotate(.03turn);  */
}

@keyframes spin {
    from {
        transform:rotate(0deg);
    }
    to {
        transform:rotate(360deg);
    }
}
</style>

<form id='simcheckform'>
 
  <table id='simchecktable' class='no-zebra'>
  	<tr>
  		<td><strong>Member Name</strong></td><td><input type="text" id="membername" name="membername" data-kind="members" /></td>
  	</tr>
  	<tr>
  		<td colspan='2'><div id='member-name-results'></div></td>
  	</tr>
  	<tr>
  		<td><strong>Member ID</strong></td><td><input type="text" id="memberid" name="memberid"/></td>
  	</tr>
  	
  </table>

  <div id="runningfor"></div>
  <div id="simcheck"></div>
  
  <!--<input type="submit" id="pushme" value="Calculate"/>-->
  <!--<input type="submit" id="report" disabled value="Show Report" />-->
  <input type="submit" id="csv" class="button" disabled value="Generate CSV" />

</form>


<div id='fetch-progress'></div>
<div id="myProgress">
  <div id="myBar"></div>
</div>

<div id='the-report'></div>

<script src="https://code.jquery.com/jquery-1.10.2.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/mustache.js/3.0.1/mustache.min.js"></script>
<script>
Mustache.tags=["[[", "]]"];

var maxRows = 10000;
var batchSize = 500;
var maxloops = maxRows / batchSize;
var loops = 0;
var rows = [];
var totalResults = 0;
var fetchResults = 0;

var memberid = '';
var membername = '';

(function() {
	var timer = null;

	$(document).ready(function() {
		console.log("ready")

		$('#memberid').bind("enterKey",function(e){
			e.preventDefault();

			$('#csv').attr('disabled',true);
			memberid = $('#memberid').val();

			$("#member-name-results").empty().hide();

			$("#the-report").empty();

			$("#runningfor").html(Mustache.render("<h2>Running for [[membername]] (ID:[[memberid]])</h2>", { membername: membername, memberid: memberid}));
			calcSimCheck();
			return false;
		});

		$('#memberid').keyup(function(e){
		    if(e.keyCode == 13)
		    {
		        $(this).trigger("enterKey");
		    }
		});


	    $('#membername').on('input', function(e) {

			clearTimeout(timer);

			setTimeout(function() {
			    var terms = $('#membername').val();
			    var kind = $('#membername').attr('data-kind');

				var results = '';
			    var memberLookupUrl = "{{ .Site.Params.apiURL }}/" + kind + "/?query=" + terms + "&rows=10{{ .Site.Params.apiUser }}";
			    $.getJSON( memberLookupUrl )
				.done(function( data ) {
					var items = data.message["items"];
					$.each (items, function(i,item) {
						results += "<a class='member-link' href='#' data-name= '" + item['primary-name'] + "' data-id='" + item['id'] + "'' title='" + item['primary-name'] + "'>" + item['primary-name'] + " (ID:" + item['id'] + ")</a><br />";
					})					

					$("#member-name-results").html(results).show();

					$(".member-link").click(function(e) {
						e.preventDefault();

			    		memberid = $(this).attr('data-id');
			    		membername = $(this).attr('data-name');

						$('#memberid').val(memberid);

						$("#member-name-results").empty().hide();

						$("#the-report").empty();

						$("#runningfor").html(Mustache.render("<h2>Running for [[membername]] (ID:[[memberid]])</h2>", { membername: membername, memberid: memberid}));
						calcSimCheck();
						return false;
					})					
				});  
			}, 750);
	    });
	});	

	$("#pushme").click(function() {

		$("#the-report").empty();
		calcSimCheck();
		return false;
    });

    $("#report").click(function() {
    	buildReport();
    	return false;
    })

    $('#csv').click(function() {
    	buildCSV();
    	return false;
    })



    function buildCSV() {

		var memberID = $('#memberid').val();

		// set rows array back to empty
		rows = [];

		// need to work out a way of iterating over the cursor to fetch all the rows?
		// will JS cope with thousands?		

		// first cursor set to * to get first set
		var nextCursor = "*";    	

		totalResults = 0;
		fetchResults = 0;

		var reportURL = "{{ .Site.Params.apiURL }}/works?rows=" + batchSize + "{{ .Site.Params.apiUser }}&filter=type:journal-article,member:";

		$("#fetch-progress").show();
		$("#fetch-progress").text('Working...');


		$("#myBar").css('width','1%');
		$("#myProgress").show();

		// before getting all the rows - add a header
		row=[];
		row.push("DOI");
		row.push("<item crawler=\"iParadigms\">");
		rows.push(row);

		fetchRows(reportURL, memberID, nextCursor);

	}	

	function fetchRows(reportURL, memberID, nextCursor) {

		if ((fetchResults != totalResults) || (totalResults == 0) ) {
			loops += 1;

			var URL = reportURL + memberID + "&cursor=" + nextCursor;

			$.getJSON( URL )
				.done(function( data ) {
					var items = data.message["items"];
					totalResults = data.message["total-results"];
					nextCursor = encodeURIComponent(data.message["next-cursor"]);

					$.each (items, function(i,item) {
						if (item["link"]) {
							linkLength = item["link"].length;
							simcheckFound = false;
							for(var i=0; i < linkLength; i++) {
								if (item["link"][i]["intended-application"] == "similarity-checking") {
									simcheckFound = true;
									row=[];
									fetchResults+=1;
								}
							}					
							if (!simcheckFound) {
								row=[];		
								row.push(item["DOI" ]);
								row.push("NULL");
								rows.push(row);
								fetchResults+=1;
							}
						} else {				
							row=[];		
							row.push(item["DOI" ]);
							row.push("NULL");
							rows.push(row);
							fetchResults+=1;
						}
					})		

					console.log("loops=" + loops + " maxloops=" + maxloops + " fetchresulrs=" + fetchResults);

					if ((fetchResults >= totalResults) || (loops >= maxloops)) {
						exportToCSV("extract.csv", rows);
						$("#fetch-progress").text('Download ready...');
						$("#myBar").css('width','100%');
					} else {
						progress = fetchResults / totalResults * 100;
						$("#myBar").css('width',progress + '%');
						$("#fetch-progress").text('Working... ' + loops*batchSize + "/" + totalResults);
						fetchRows(reportURL,memberID,nextCursor);
					}
					
				}); 

		} 

    }

    function exportToCSV(filename, rows) {
        var processRow = function (row) {
            var finalVal = '';
            for (var j = 0; j < row.length; j++) {
                var innerValue = row[j] === null ? '' : row[j].toString();
                if (row[j] instanceof Date) {
                    innerValue = row[j].toLocaleString();
                };
                var result = innerValue.replace(/"/g, '""');
                if (result.search(/("|,|\n)/g) >= 0)
                    result = '"' + result + '"';
                if (j > 0)
                    finalVal += ',';
                finalVal += result;
            }
            return finalVal + '\n';
        };

        var csvFile = '';
        for (var i = 0; i < rows.length; i++) {
            csvFile += processRow(rows[i]);
        }

        var blob = new Blob([csvFile], { type: 'text/csv;charset=utf-8;' });
        if (navigator.msSaveBlob) { // IE 10+
            navigator.msSaveBlob(blob, filename);
        } else {
            var link = document.createElement("a");
            if (link.download !== undefined) { // feature detection
                // Browsers that support HTML5 download attribute
                var url = URL.createObjectURL(blob);
                link.setAttribute("href", url);
                link.setAttribute("download", filename);
                link.style.visibility = 'hidden';
                document.body.appendChild(link);
                link.click();
                document.body.removeChild(link);
            }
        }
    }


    function buildReport() {


		var memberID = $('#memberid').val();
    	var reportURL = "{{ .Site.Params.apiURL }}/works?filter=type:journal-article,member:" + memberID + "&rows=500{{ .Site.Params.apiUser }}";

    	var results = '';

    	$.getJSON( reportURL )
			.done(function( data ) {
				var items = data.message["items"];

				results += "<table class='simcheck-list'><thead><tr><th>DOI</th><th>URL</th></tr></thead><tbody>"

				$.each (items, function(i,item) {
					results += "<tr>";
					if (item["link"]) {
						results += "<td>" + item["DOI" ] + "</td><td>" + item["link"][0]["URL"] + "</td>";
					} else {
						results += "<td>" + item["DOI" ] + "</td><td>NULL</td>";
					}
					results += "</tr>";
				})					

				results += "</tbody></table>"
				$("#the-report").html(results);
				$('.simcheck-list').DataTable({
				    "paging": false,
				    "searching": false, 
				    "buttons": [
				    ],   
				    "sDom": '<"top"<"info"lfpi><"actions"B><"clear">>rt<"bottom">',
				    "infoCallback": function( settings, start, end, max, total, pre ) {
				      return "Maximum " + total + " rows. For a full report choose Generate CSV";
				    }
				  });

				
			});  


    }

	function calcSimCheck() {

		$("#myProgress").hide();
		$("#fetch-progress").hide();

		//$('#csv').attr('disabled',true');
		$("#report").attr("disabled");

		$("#simcheck").html("<div></div>");
		var memberID = $('#memberid').val();
		var prefix = $('#prefix').val();
		
		var searchByMemberID = "member:"+memberID;
		var searchByPrefix = "prefix:"+prefix;

		var searchBy = searchByMemberID;
		var resultText = "";

		if (memberID == '') {
			searchBy = searchByPrefix;
			resultText = "For Single Prefix " + prefix;
		}

		var simCheckTotalURL = "{{ .Site.Params.apiURL }}/works?filter=full-text.application:similarity-checking,type:journal-article,"+searchBy+"&rows=0{{ .Site.Params.apiUser }}";

		var journalTotalURL = "{{ .Site.Params.apiURL }}/works?filter=type:journal-article,"+searchBy+"&rows=0{{ .Site.Params.apiUser }}";

		var simCheckTotal = 0;
		var journalTotal = 0;

		$.getJSON( simCheckTotalURL )
		.done(function( data ) {
			simCheckTotal = data.message["total-results"];

			$.getJSON( journalTotalURL )
			.done(function( data ) {
				journalTotal = data.message["total-results"];

				var percentage = simCheckTotal / journalTotal * 100.0;
				percentage = percentage.toFixed(2);
				if (journalTotal == 0) { percentage = 0;}

				$("#runningfor").html(Mustache.render("<h2>Results for [[membername]] (ID:[[memberid]])</h2>", { membername: membername, memberid: memberid}));

				$("#simcheck").html(Mustache.render("[[resultText]]<h3>[[simCheckTotal]]/[[journalTotal]] = [[percentage]]%</h3>",
					{
						resultText:resultText,
						simCheckTotal:simCheckTotal,
						journalTotal:journalTotal,
						percentage:percentage
					}));

				// Member is eligible (over 90%) DOIs registered no matter if under/over 10k DOIs - 'above' & HIDE CSV
				if (percentage >= 90) {
					$('.simcheck-above').show();
					$('.simcheck-above10k').hide();
					$('.simcheck-below').hide();
					$('.simcheck-help').hide();
					$('#csv').attr('disabled',true);
				} else {
					$('.simcheck-above').hide();
				}

				// Member is ineligible as they have some DOIs registered but less than 90% Similarity Check URLs and they have fewer than 10k DOIs registered altogether - 'below' & SHOW CSV
				if ((percentage < 90) && (journalTotal < 10000)) {
					$('.simcheck-above').hide();
					$('.simcheck-above10k').hide();
					$('.simcheck-below').show();
					$('.simcheck-help').hide();
					$('#csv').attr('disabled',false);
				// Member is ineligible as they have some DOIs registered but less than 90% Similarity Check URLs and they have MORE than 10k DOIs registered altogether - 'above10k' & HIDE CSV
				} else if ((percentage < 90) && (journalTotal >=10000)) {
					$('.simcheck-above').hide();
					$('.simcheck-above10k').show();
					$('.simcheck-below').hide();
					$('.simcheck-help').hide();
					$('#csv').attr('disabled',true);
				} else {
					$('.simcheck-below').hide();
					$('.simcheck-above10k').hide();
				}

				// Member is ineligible as they haven't yet registered any content with us - help & HIDE CSV
				if (journalTotal == 0) {
					$('.simcheck-above').hide();
					$('.simcheck-above10k').hide();
					$('.simcheck-below').hide();
					$('.simcheck-help').show();
					$('#csv').attr('disabled',true);
				} else {
					$('.simcheck-help').hide();
				}


				$("#pushme").hide();

				
				// this is hidden anyway
				$("#report").removeAttr("disabled");
				
			});  
		});
	};


})();
</script>
